/*
 *  Copyright (c) 2009 Cyrille Berger <cberger@cberger.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation;
 * either version 2, or (at your option) any later version of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#ifndef _OPENCTL_TEMPLATE_LEXER_H_
#define _OPENCTL_TEMPLATE_LEXER_H_

#include <GTLCore/LexerBase_p.h>
#include <OpenCTL/Export.h>

namespace OpenCTL {
  /**
   * @internal
   * Lexer for the CTL template.
   */
  class OPENCTL_TESTS_EXPORT TemplateLexer : public GTLCore::LexerBase {
    public:
      TemplateLexer(std::istream* sstream);
      ~TemplateLexer();
      /**
       * @return the next token
       */
      GTLCore::Token nextToken();
    private:
      TemplateLexer(const TemplateLexer& rhs) : LexerBase(rhs) {}
      TemplateLexer& operator=(const TemplateLexer& ) { return *this; }
  };
}

#endif
